/*
 *    VisNow
 *    Copyright (C) 2006-2019 University of Warsaw, ICM
 *    Copyright (C) 2020 onward visnow.org
 *    All rights reserved.
 * 
 *  DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
 *
 *  This code is free software; you can redistribute it and/or modify it
 *  under the terms of the GNU General Public License version 3, 
 *  or (at your option) any later version, as published by the Free Software Foundation.  
 *  The authors designate this particular file as subject to the "Classpath" exception 
 *  as provided in the LICENSE file that accompanied this code.
 *
 *  This code is distributed in the hope that it will be useful, but WITHOUT
 *  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 *  FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 *  version 3 for more details (a copy is included in the LICENSE file that
 *  accompanied this code).
 *
 *  You should have received a copy of the GNU General Public License version 3
 *  along with this work; if not, see http://www.gnu.org/licenses/gpl-3.0.txt 
 *
 *  Please contact visnow.org or visit www.visnow.org if you need additional information or
 *  have any questions.
 *
 */

package org.visnow.vn.lib.basic.writers.FieldWriter;

import java.io.File;
import javax.swing.JFileChooser;
import javax.swing.filechooser.FileNameExtensionFilter;
import org.visnow.vn.engine.core.ParameterProxy;
import org.visnow.vn.engine.core.Parameters;
import static org.visnow.vn.lib.basic.writers.FieldWriter.FieldWriterShared.*;
import org.visnow.vn.system.main.VisNow;
import org.visnow.vn.system.swing.filechooser.VNFileChooser;

public class GUI extends javax.swing.JPanel
{

    private String lastPath = null;
    private Parameters parameters;

    /**
     * Creates new form EmptyVisnowModuleGUI
     */
    public GUI()
    {
        initComponents();
    }

    void setParameters(Parameters parameters)
    {
        this.parameters = parameters;
    }

    void updateGUI(ParameterProxy p)
    {
        switch (p.get(FIELDFORMAT)) {
            case SERIALIZED:
                serializedButton.setSelected(true);
                break;
            case VNF_ASCII:
                asciiButton.setSelected(true);
                break;
            case VNF_BINARY:
                binaryButton.setSelected(true);
                break;
            default:
                serializedButton.setSelected(true);
                break;
        }
        tfFileName.setText(p.get(FILENAME));
    }

    /**
     * This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents()
    {
        java.awt.GridBagConstraints gridBagConstraints;

        formatGroup = new javax.swing.ButtonGroup();
        fileChooser = new javax.swing.JFileChooser();
        selectButton = new javax.swing.JButton();
        tfFileName = new javax.swing.JTextField();
        serializedButton = new javax.swing.JRadioButton();
        asciiButton = new javax.swing.JRadioButton();
        binaryButton = new javax.swing.JRadioButton();
        writeButton = new javax.swing.JButton();
        jPanel1 = new javax.swing.JPanel();

        setMinimumSize(new java.awt.Dimension(180, 122));
        setOpaque(false);
        setPreferredSize(new java.awt.Dimension(200, 200));
        setLayout(new java.awt.GridBagLayout());

        java.util.ResourceBundle bundle = java.util.ResourceBundle.getBundle("org/visnow/vn/lib/basic/writers/FieldWriter/Bundle"); // NOI18N
        selectButton.setText(bundle.getString("GUI.selectButton.text")); // NOI18N
        selectButton.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                selectButtonActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(0, 0, 0, 1);
        add(selectButton, gridBagConstraints);

        tfFileName.setText(bundle.getString("GUI.tfFileName.text")); // NOI18N
        tfFileName.setMinimumSize(new java.awt.Dimension(4, 22));
        tfFileName.setPreferredSize(new java.awt.Dimension(78, 22));
        tfFileName.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                tfFileNameActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(2, 0, 2, 0);
        add(tfFileName, gridBagConstraints);

        formatGroup.add(serializedButton);
        serializedButton.setSelected(true);
        serializedButton.setText(bundle.getString("GUI.serializedButton.text")); // NOI18N
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        add(serializedButton, gridBagConstraints);

        formatGroup.add(asciiButton);
        asciiButton.setLabel(bundle.getString("GUI.asciiButton.label")); // NOI18N
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        add(asciiButton, gridBagConstraints);

        formatGroup.add(binaryButton);
        binaryButton.setActionCommand(bundle.getString("GUI.binaryButton.actionCommand")); // NOI18N
        binaryButton.setLabel(bundle.getString("GUI.binaryButton.label")); // NOI18N
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        add(binaryButton, gridBagConstraints);

        writeButton.setText(bundle.getString("GUI.writeButton.text")); // NOI18N
        writeButton.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                writeButtonActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 5;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(0, 0, 0, 1);
        add(writeButton, gridBagConstraints);

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 180, Short.MAX_VALUE)
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 225, Short.MAX_VALUE)
        );

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 6;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weighty = 1.0;
        add(jPanel1, gridBagConstraints);
    }// </editor-fold>//GEN-END:initComponents

    private void tfFileNameActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_tfFileNameActionPerformed
    {//GEN-HEADEREND:event_tfFileNameActionPerformed
        parameters.setParameterActive(false);
        parameters.set(FILENAME, tfFileName.getText());
        parameters.setParameterActive(true);
    }//GEN-LAST:event_tfFileNameActionPerformed

    private void writeButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_writeButtonActionPerformed
    {//GEN-HEADEREND:event_writeButtonActionPerformed
        String path = parameters.get(FILENAME);
        if (path != null) {
            parameters.set(FIELDFORMAT, serializedButton.isSelected() ?
                                        FieldWriterFileFormat.SERIALIZED :
                                        (asciiButton.isSelected() ?
                                                FieldWriterFileFormat.VNF_ASCII :
                                                FieldWriterFileFormat.VNF_BINARY));
            parameters.set(DO_WRITE, !parameters.get(DO_WRITE));
        }
    }//GEN-LAST:event_writeButtonActionPerformed

    private void selectButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_selectButtonActionPerformed
    {//GEN-HEADEREND:event_selectButtonActionPerformed
        if (lastPath == null)
            fileChooser.setCurrentDirectory(new File(VisNow.get().getMainConfig().getUsableDataPath(FieldWriter.class
            )));
        else
            fileChooser.setCurrentDirectory(new File(lastPath));
        FileNameExtensionFilter fieldFilter;
        if (serializedButton.isSelected()) {
            fieldFilter = new FileNameExtensionFilter("VisNow Field files (serialized)", "vns", "VNS");
        } else {
            fieldFilter = new FileNameExtensionFilter("VisNow Field files (VNF)", "vnf", "VNF");
        }
        fileChooser.setFileFilter(fieldFilter);
        String path;
        int returnVal = fileChooser.showDialog(this, "Select");
        if (returnVal == JFileChooser.APPROVE_OPTION) {
            if (!serializedButton.isSelected()) {
                path = VNFileChooser.filenameWithExtenstionAddedIfNecessary(fileChooser.getSelectedFile(), new FileNameExtensionFilter("", "vnf", "VNF"));
            } else {
                path = VNFileChooser.filenameWithExtenstionAddedIfNecessary(fileChooser.getSelectedFile(), new FileNameExtensionFilter("", "vns", "VNS"));
            }
            tfFileName.setText(path);
            lastPath = path.substring(0, path.lastIndexOf(File.separator));
            VisNow
                .get().getMainConfig().setLastDataPath(lastPath, FieldWriter.class
                );
            parameters.setParameterActive(false);
            parameters.set(FILENAME, path);
            parameters.setParameterActive(true);
        }
    }//GEN-LAST:event_selectButtonActionPerformed

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JRadioButton asciiButton;
    private javax.swing.JRadioButton binaryButton;
    private javax.swing.JFileChooser fileChooser;
    private javax.swing.ButtonGroup formatGroup;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JButton selectButton;
    private javax.swing.JRadioButton serializedButton;
    private javax.swing.JTextField tfFileName;
    private javax.swing.JButton writeButton;
    // End of variables declaration//GEN-END:variables
}
